package org.example;
import org.eclipse.paho.client.mqttv3.*;


public class RabbitMQMQTTConsumer {
    public static void main(String[] args) {
        String broker = "ssl://xxxxxx.rabbitmq.volces.com:8883"; // MQTT broker server address
        /* String url = "tcp://xxxxxx.rabbitmq.ivolces.com:1883"; // MQTT broker server address, public non-SSL connection or private network connection */
        String clientId = "consumer-xxx"; // Client ID
        String topic = "xxx"; // Topic to subscribe to
        String username = "xxxx"; // RabbitMQ username
        String password = "xxxx"; // RabbitMQ password

        try {
            MqttClient client = new MqttClient(broker, clientId);
            MqttConnectOptions connOpts = new MqttConnectOptions();
            connOpts.setCleanSession(true);
            connOpts.setUserName(username);
            connOpts.setPassword(password.toCharArray());

            // Set up message arrival callback processing
            client.setCallback(new MqttCallback() {
                @Override
                public void connectionLost(Throwable cause) {
                    System.out.println("Connection lost: " + cause.getMessage());
                }

                @Override
                public void messageArrived(String topic, MqttMessage message) throws Exception {
                    System.out.println("Received message from topic: " + topic);
                    System.out.println("Message: " + new String(message.getPayload()));
                }

                @Override
                public void deliveryComplete(IMqttDeliveryToken token) {
                }
            });

            // Connect to the broker
            client.connect(connOpts);

            // Subscribe to the topic
            client.subscribe(topic);

            // Wait for messages to arrive
            synchronized (client) {
                client.wait();
            }

            // Disconnect from the broker
            client.disconnect();
        } catch (MqttException | InterruptedException e) {
            e.printStackTrace();
        }
    }
}


public class RabbitMQMQTTProducer {
    // Publisher client
    public static void main(String[] args) {
        String url = "ssl://xxxxxxx:8883"; // MQTT server address, public SSL connection
        /* String url = "tcp://xxxxxx:1883"; // MQTT broker address, public non-SSL connection or private network connection */
        String clientId = "publisher-xxxx"; // Client ID
        String topic = "xxxx"; // Topic to publish to
        String message = "Hello, MQTT!"; // Message content to publish
        String username = "****"; // RabbitMQ username
        String password = "*****"; // RabbitMQ password

        try {
            MqttClient client = new MqttClient(url, clientId);
            MqttConnectOptions connOpts = new MqttConnectOptions();
            connOpts.setCleanSession(true);
            connOpts.setUserName(username);
            connOpts.setPassword(password.toCharArray());

            // Connect to the broker
            client.connect(connOpts);

            // Create a message object
            MqttMessage mqttMessage = new MqttMessage(message.getBytes());
            mqttMessage.setQos(1); // Set the QoS (Quality of Service) level of the message

            // Publish the message
            client.publish(topic, mqttMessage);
            System.out.println("Success: Published message");

            // Disconnect from the broker
            client.disconnect();
        } catch (MqttException e) {
            e.printStackTrace();
        }
    }
}