package org.example;
import org.eclipse.paho.client.mqttv3.*;


public class RabbitMQMQTTProducer {
    // Publisher client
    public static void main(String[] args) {
        String url = "ssl://xxxxxxx:8883"; // MQTT server address, public SSL connection
        /* String url = "tcp://xxxxxx:1883"; // MQTT broker address, public non-SSL connection or private network connection */
        String clientId = "publisher-xxxx"; // Client ID
        String topic = "xxxx"; // Topic to publish to
        String message = "Hello, MQTT!"; // Message content to publish
        String username = "****"; // RabbitMQ username
        String password = "*****"; // RabbitMQ password

        try {
            MqttClient client = new MqttClient(url, clientId);
            MqttConnectOptions connOpts = new MqttConnectOptions();
            connOpts.setCleanSession(true);
            connOpts.setUserName(username);
            connOpts.setPassword(password.toCharArray());

            // Connect to the broker
            client.connect(connOpts);

            // Create a message object
            MqttMessage mqttMessage = new MqttMessage(message.getBytes());
            mqttMessage.setQos(1); // Set the QoS (Quality of Service) level of the message

            // Publish the message
            client.publish(topic, mqttMessage);
            System.out.println("Success: Published message");

            // Disconnect from the broker
            client.disconnect();
        } catch (MqttException e) {
            e.printStackTrace();
        }
    }
}
